<?php
/**
* ProofReader - A Mambo/Joomla! Component for misprint reporting
* @version 1.0 RC4 2007-04-10
* @package proofreader
* @copyright (C) 2005-2007 by Alexandr Balashov aka ERA - All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL.
* ProofReader is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
global $mosConfig_lang;

  require($mosConfig_absolute_path."/administrator/components/com_proofreader/config.proofreader.php");
  if (file_exists($mosConfig_absolute_path.'/administrator/components/com_proofreader/languages/admin.'.$mosConfig_lang.'.php')) {
    $file = $mosConfig_absolute_path.'/administrator/components/com_proofreader/languages/admin.'.$mosConfig_lang.'.php';
  } else {
    $file = $mosConfig_absolute_path.'/administrator/components/com_proofreader/languages/admin.english.php';
  }
  require($file);

require_once( $mosConfig_absolute_path."/administrator/components/com_proofreader/class.proofreader.php");
require_once( $mainframe->getPath( 'admin_html' ) );


$option	= strval( mosGetParam( $_REQUEST, 'option', '') );
if ($option == '') {
	$option	= strval( mosGetParam( $_POST, 'option', '') );
};

$task = mosGetParam( $_REQUEST, 'task', '' );
if ($task == '') {
	$task = mosGetParam( $_POST, 'task', '' );
};

$pr_id = mosGetParam( $_REQUEST, 'pr_id', array(0) );
if ($pr_id == array(0)) {
	$pr_id = mosGetParam( $_POST, 'pr_id', array(0) );
};

switch ($task) {
  case "publish":
    publishMistake( $pr_id, 'y', $option );
    break;

  case "unpublish":
    publishMistake( $pr_id, 'n', $option );
    break;

  case "new":
    editMistake( $option, 0 );
    break;

  case "edit":
    editMistake( $option, $pr_id[0] );
    break;

  case "remove":
    removeMistake( $pr_id, $option );
    break;

  case "save":
    saveMistake( $option );
    break;

  case "config":
    showConfig( $option );
    break;

  case "savesettings":
    saveConfig ($option);
    break;

  case "about":
    showAbout();
    break;

  default:
    showMistakes( $option, $database );
    break;
}



function showMistakes ( $option, &$db ) {
  global $database, $mainframe, $mosConfig_list_limit;
  $search = trim( strtolower( mosGetParam( $_POST, 'search', '' ) ) );
  $limit = intval( mosGetParam( $_POST, 'limit', 10 ) );
  $limitstart = intval( mosGetParam( $_POST, 'limitstart', 0 ) );

  $where = array();

  $filter_author	= $mainframe->getUserStateFromRequest( "filter_author{$option}", 'filter_author', 0 );
  $filter_status	= $mainframe->getUserStateFromRequest( "status{$option}", 'status', "" );

  if ($search) {
    $where[] = "LOWER(pr_mistake) LIKE '%$search%' or LOWER(pr_comment) LIKE '%$search%'";
  }

  if ( $filter_author <> "" ) {
	$where[] = "pr_author = '$filter_author'";
  }

  if ( $filter_status <> "" ) {
	$where[] = "pr_close = '$filter_status'";
  }

  $db->setQuery( "SELECT count(*) FROM #__proofreader AS a".(count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : "") );
  $total = $db->loadResult();
  echo $db->getErrorMsg();


  $db->setQuery( "SELECT * FROM #__proofreader"
    . (count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : "")
    . "\nORDER BY pr_id DESC"
    . "\nLIMIT $limitstart,$limit"
  );

  $rows = $db->loadObjectList();
  if ($db->getErrorNum()) {
    echo $db->stderr();
    return false;
  }

  include_once("includes/pageNavigation.php");
  $pageNav = new mosPageNav( $total, $limitstart, $limit  );


  $database->setQuery( "SELECT DISTINCT pr_author FROM #__proofreader ORDER BY pr_author");
  $mistusers = $database->loadObjectList();

  $lists['author'][] = mosHTML::makeOption( '', '--== '._PROOFREADER_ADMINVIEW_AUTHORFILTER.' ==--' );

  for ($i=0, $n=count( $mistusers ); $i < $n; $i++) {
	$mistuser = &$mistusers[$i];
	$lists['author'][] = mosHTML::makeOption( $mistuser->pr_author, $mistuser->pr_author );
  };
  $lists['author'] = mosHTML::selectList( $lists['author'], 'filter_author', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $filter_author );

  $lists['status'][] = mosHTML::makeOption( '', '--== '._PROOFREADER_ADMINVIEW_MISTAKESTATUS_ALL.' ==--' );
  $lists['status'][] = mosHTML::makeOption( 'y', _PROOFREADER_ADMINVIEW_MISTAKESTATUS_YES );
  $lists['status'][] = mosHTML::makeOption( 'n', _PROOFREADER_ADMINVIEW_MISTAKESTATUS_NO );
  $lists['status'] = mosHTML::selectList( $lists['status'], 'status', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $filter_status );

  HTML_Proofreader::showMistakesEntries( $option, $lists, $rows, $search, $pageNav );
}


function removeMistake( $cid, $option ) {
  global $database;
 
  if (count( $cid )) {
    $cids = implode( ',', $cid );
    $database->setQuery( "DELETE FROM #__proofreader WHERE pr_id IN ($cids)" );
    if (!$database->query()) {
      echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
    }
  }
  mosRedirect( "index2.php?option=$option" );
}


function publishMistake( $cid=null, $publish='n',  $option ) {
  global $database;

  if (!is_array( $cid ) || count( $cid ) < 1) {
  	if ($publish == 'y') {
		$action = 'publish';
  	} else {
		$action = 'unpublish';
  	};
    echo "<script> alert('"._PROOFREADER_ADMINVIEW_CLOSEMISTAKEERROR." $action'); window.history.go(-1);</script>\n";
    exit;
  }

  $cids = implode( ',', $cid );

  $database->setQuery( "UPDATE #__proofreader SET pr_close='$publish' WHERE pr_id IN ($cids)" );
  if (!$database->query()) {
    echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
    exit();
  }

  mosRedirect( "index2.php?option=$option" );
}


function editMistake( $option, $pr_id ) {
  global $mosConfig_absolute_path, $mosConfig_live_site, $database;
 
  $row = new mosProofreader($database );

  if ($pr_id) {
    $database->setQuery( "SELECT * FROM #__proofreader WHERE pr_id = $pr_id" );
    $rows = $database->loadObjectList();
    $row = $rows[0];
  } else {
    $row->close = 0;
  }

  $yesno[] = mosHTML::makeOption( 'n', _PROOFREADER_NO );
  $yesno[] = mosHTML::makeOption( 'y', _PROOFREADER_YES );

  $publist = mosHTML::selectList( $yesno, 'pr_close', 'class="inputbox" size="2"', 'value', 'text', $row->pr_close);

  HTML_Proofreader::editMistake( $option, $row, $publist );
}


function saveMistake( $option, &$db ) {
  global $database;

  $row = new mosProofreader( $database );
  if (!$row->bind( $_POST )) {
    echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
    exit();
  }
  $row->_tbl_key = "pr_id";

  if (!$row->store()) {
    echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
    exit();
  }

  mosRedirect( "index2.php?option=$option" );
}


function showConfig( $option ) {
	global $database;

	$pr_offline_message = '';
	$pr_registered_only_message = '';
	$pr_thankuser_message = '';

	$database->setQuery( "SELECT * FROM #__proofreader_conf" );
    $rows = $database->loadObjectList();
    if (is_array($rows)) {
    	foreach ($rows as $row) {
			if ($row->param_name === "Offline message") {
				$pr_offline_message = $row->param_value;
			} elseif ($row->param_name === "Only registered") {
				$pr_registered_only_message = $row->param_value;
			} elseif ($row->param_name === "Thanks user message") {
				$pr_thankuser_message = $row->param_value;
			};
    	};
    };

	HTML_Proofreader::showConfig( $option, $pr_offline_message, $pr_registered_only_message, $pr_thankuser_message );

}


function saveConfig ($option) {
	global $mosConfig_absolute_path, $database;
	$configfile = $mosConfig_absolute_path."/administrator/components/com_proofreader/config.proofreader.php";
	@chmod ($configfile, 0744);
	$permission = is_writable($configfile);
	if (!$permission) {
		mosRedirect("index2.php?option=$option&task=config", _PROOFREADER_ADMINCONFIG_NOTWRITEBLE);
		break;
	}

//	$pr_encode_page =		mosGetParam( $_POST, 'pr_encode_page', 'windows-1251');
	$pr_offline  =			mosGetParam( $_POST, 'pr_offline', '0' );
	$pr_registered =		mosGetParam( $_POST, 'pr_registered', '0' );
	$pr_notify =			mosGetParam( $_POST, 'pr_notify', '1' );
	$pr_notify_email =		mosGetParam( $_POST, 'pr_notify_email', '' );
	$pr_variant_enable =		mosGetParam( $_POST, 'pr_variant_enable', '1' );
	$pr_comment_enable =		mosGetParam( $_POST, 'pr_comment_enable', '1' );
	$pr_duplicate_enable =		mosGetParam( $_POST, 'pr_duplicate_enable', '1' );
	$pr_image_enable =		mosGetParam( $_POST, 'pr_image_enable', '0' );
	$pr_ip_count =			mosGetParam( $_POST, 'pr_ip_count', '0' );
	$pr_mistake_length =		mosGetParam( $_POST, 'pr_mistake_length', '250' );
	$pr_variant_length =		mosGetParam( $_POST, 'pr_variant_length', '250' );
	$pr_comment_length =		mosGetParam( $_POST, 'pr_comment_length', '250' );
	$pr_module_debug_mode =		mosGetParam( $_POST, 'pr_module_debug_mode', '0' );
	$pr_module_title_color =	mosGetParam( $_POST, 'pr_module_title_color', 'ffffff' );
	$pr_module_title_bgcolor =	mosGetParam( $_POST, 'pr_module_title_bgcolor', 'FB8712' );
	$pr_module_button_css_class =	mosGetParam( $_POST, 'pr_module_button_css_class', '' );
	$pr_module_bgcolor =		mosGetParam( $_POST, 'pr_module_bgcolor', 'ffffff' );
	$pr_adminview_mistake =		mosGetParam( $_POST, 'pr_adminview_mistake', '1' );
	$pr_adminview_variant =		mosGetParam( $_POST, 'pr_adminview_variant', '1' );
	$pr_adminview_comment =		mosGetParam( $_POST, 'pr_adminview_comment', '0' );
	$pr_adminview_url =		mosGetParam( $_POST, 'pr_adminview_url', '1' );
	$pr_adminview_close =		mosGetParam( $_POST, 'pr_adminview_close', '1' );
	$pr_adminview_date =		mosGetParam( $_POST, 'pr_adminview_date', '1' );
	$pr_adminview_author =		mosGetParam( $_POST, 'pr_adminview_author', '1' );
	$pr_adminview_ip =		mosGetParam( $_POST, 'pr_adminview_ip', '1' );
	$pr_mailsubject =		addslashes( mosGetParam( $_POST, 'pr_mailsubject', '' ));
	// hook params
	$pr_alt_hook =		mosGetParam( $_POST, 'pr_alt_hook', '0' );
	$pr_shift_hook =	mosGetParam( $_POST, 'pr_shift_hook', '1' );
	$pr_ctrl_hook =		mosGetParam( $_POST, 'pr_ctrl_hook', '0' );

	$config = "<?php\n";
//	$config .= "\$pr_encode_page = \"$pr_encode_page\";\n";
	$config .= "\$pr_offline = \"$pr_offline\";\n";
	$config .= "\$pr_registered = \"$pr_registered\";\n";
	$config .= "\$pr_notify = \"$pr_notify\";\n";
	$config .= "\$pr_notify_email = \"$pr_notify_email\";\n";
	$config .= "\$pr_variant_enable = \"$pr_variant_enable\";\n";
	$config .= "\$pr_comment_enable = \"$pr_comment_enable\";\n";
	$config .= "\$pr_duplicate_enable = \"$pr_duplicate_enable\";\n";
	$config .= "\$pr_image_enable = \"$pr_image_enable\";\n";
	$config .= "\$pr_ip_count = \"$pr_ip_count\";\n";
	$config .= "\$pr_mistake_length = \"$pr_mistake_length\";\n";
	$config .= "\$pr_variant_length = \"$pr_variant_length\";\n";
	$config .= "\$pr_comment_length = \"$pr_comment_length\";\n";
	$config .= "\$pr_module_debug_mode = \"$pr_module_debug_mode\";\n";
	$config .= "\$pr_module_title_color = \"$pr_module_title_color\";\n";
	$config .= "\$pr_module_title_bgcolor = \"$pr_module_title_bgcolor\";\n";
	$config .= "\$pr_module_bgcolor = \"$pr_module_bgcolor\";\n";
	$config .= "\$pr_module_button_css_class = \"$pr_module_button_css_class\";\n";
	$config .= "\$pr_adminview_mistake = \"$pr_adminview_mistake\";\n";
	$config .= "\$pr_adminview_variant = \"$pr_adminview_variant\";\n";
	$config .= "\$pr_adminview_comment = \"$pr_adminview_comment\";\n";
	$config .= "\$pr_adminview_url = \"$pr_adminview_url\";\n";
	$config .= "\$pr_adminview_close = \"$pr_adminview_close\";\n";
	$config .= "\$pr_adminview_date = \"$pr_adminview_date\";\n";
	$config .= "\$pr_adminview_author = \"$pr_adminview_author\";\n";
	$config .= "\$pr_adminview_ip = \"$pr_adminview_ip\";\n";
	$config .= "\$pr_mailsubject = \"$pr_mailsubject\";\n";
	// hook
	$config .= "\$pr_alt_hook = \"$pr_alt_hook\";\n";
	$config .= "\$pr_shift_hook = \"$pr_shift_hook\";\n";
	$config .= "\$pr_ctrl_hook = \"$pr_ctrl_hook\";\n";

	$config .= "?>";

	if ($fp = fopen($configfile, "w")) {
		fputs($fp, $config, strlen($config));
		fclose ($fp);
	}
	@chmod ($configfile, 0644);


	$pr_registered_only_message = addslashes( mosGetParam( $_POST, 'pr_registered_only_message', '' ));
	$pr_thankuser_message = addslashes( mosGetParam( $_POST, 'pr_thankuser_message', '' ));
	$pr_offline_message = addslashes( mosGetParam( $_POST, 'pr_offline_message', '' ));

	$database->setQuery( "SELECT * FROM #__proofreader_conf" );
    $rows = $database->loadObjectList();
    $pr_registered_only_message_b = 0;
    $pr_thankuser_message_b = 0;
    $pr_offline_message_b = 0;
    if (is_array($rows)) {
    	foreach ($rows as $row) {
			switch ($row->param_name) {
				case "Offline message":
					$pr_offline_message_b = 1;
				case "Only registered":
					$pr_registered_only_message_b = 1;
				case "Thanks user message":
					$pr_thankuser_message_b = 1;
			}
    	};
    };

    if ($pr_registered_only_message_b) {
    	$database->setQuery( "UPDATE #__proofreader_conf SET param_value = '".$pr_registered_only_message."' WHERE param_name = 'Only registered' " );
    	$database->query();
    } else {
    	$database->setQuery( "INSERT INTO #__proofreader_conf (param_id, param_name, param_value) VALUES (1, 'Only registered', '".$pr_registered_only_message."' ) " );
    	$database->query();
    };
    if ($pr_thankuser_message_b) {
    	$database->setQuery( "UPDATE #__proofreader_conf SET param_value = '".$pr_thankuser_message."' WHERE param_name = 'Thanks user message' " );
    	$database->query();
    } else {
    	$database->setQuery( "INSERT INTO #__proofreader_conf (param_id, param_name, param_value) VALUES (2, 'Thanks user message', '".$pr_thankuser_message."' ) " );
    	$database->query();
    };
    if ($pr_offline_message_b) {
    	$database->setQuery( "UPDATE #__proofreader_conf SET param_value = '".$pr_offline_message."' WHERE param_name = 'Offline message' " );
    	$database->query();
    } else {
    	$database->setQuery( "INSERT INTO #__proofreader_conf (param_id, param_name, param_value) VALUES (3, 'Offline message', '".$pr_offline_message."' ) " );
    	$database->query();
    };


	mosRedirect("index2.php?option=$option&task=config", _PROOFREADER_ADMINCONFIG_SAVED);
}


function showAbout() {
	HTML_Proofreader::showAbout();
}


?>