<?
/**
* ProofReader - A Mambo/Joomla! Component for misprint reporting
* @version 1.0 RC4 2007-04-10
* @package proofreader
* @copyright (C) 2005-2007 by Alexandr Balashov aka ERA - All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL.
* ProofReader is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

global $mosConfig_absolute_path, $mosConfig_lang;

//require($mosConfig_absolute_path."/administrator/components/com_proofreader/config.proofreader.php");

if (file_exists($mosConfig_absolute_path.'/administrator/components/com_proofreader/languages/admin.'.$mosConfig_lang.'.php')) {
	$file = $mosConfig_absolute_path.'/administrator/components/com_proofreader/languages/admin.'.$mosConfig_lang.'.php';
} else {
	$file = $mosConfig_absolute_path.'/administrator/components/com_proofreader/languages/admin.english.php';
}
require($file);



class ProofreaderInstallerHTML {

	var $releaseDate = null;
	var $releaseVersion = '1.2';
	var $messages = array();
	var $warnings = array();
	var $xmlDoc = null;

	function ProofreaderInstallerHTML() {
		global $mosConfig_absolute_path, $mosConfig_live_site;

		require_once( $mosConfig_absolute_path . '/includes/domit/xml_domit_lite_include.php' );

		$this->xmlDoc = new DOMIT_Lite_Document();
		$this->xmlDoc->resolveErrors( false );
		if ($this->xmlDoc->loadXML( dirname(__FILE__) . '/proofreader.xml', false, true )) {
			$root = &$this->xmlDoc->documentElement;
			if (($root->getTagName() == 'mosinstall') 
			&& ($root->getAttribute( "type" ) == "component")) {
				$element 		= &$root->getElementsByPath('creationDate', 1);
				$this->releaseDate 	= $element ? $element->getText() : date();
				$element 		= &$root->getElementsByPath('version', 1);
				$this->releaseVersion	= $element ? $element->getText() : '';
			}
		}
	}

	function setFilePermissions($filePath) {
		if (is_file( $filePath )) {
			if (!is_writable( $filePath ))
				@chmod( $filePath, 0666 );
			if (!is_writable( dirname( $filePath ) ))
				@chmod( dirname( $filePath ), 0777 );
		}
	}

	function setPermissions() {
		global $mosConfig_absolute_path;

		$_FRONTEND_PATH = $mosConfig_absolute_path . '/components/com_proofreader/';
		$_BACKEND_PATH = $mosConfig_absolute_path . '/administrator/components/com_proofreader/';

		$xmlDoc =& $this->xmlDoc;
		$root =& $xmlDoc->documentElement;

		$files_element =& $root->getElementsByPath( 'files', 1 );
		$files = $files_element->childNodes;

		if ($files !== null) {
			foreach ($files as $file) {
				if ($file->getAttribute('writable') === 'yes') {
	                        	$this->setFilePermissions($_FRONTEND_PATH . $file->getText());
				}
			}
		}

		$files_element =& $root->getElementsByPath( 'administration/files', 1 );
		$files = $files_element->childNodes;

		if ($files !== null) {
			foreach ($files as $file) {
				if ($file->getAttribute('writable') === 'yes') {
	                        	$this->setFilePermissions($_BACKEND_PATH . $file->getText());
				}
			}
		}

	}

	function addMessage( $message, $status = true) {
		$msg['text']	= $message;
		$msg['status']	= $status;
		$this->messages[] = $msg;
	}

	function addWarning( $message) {
		$msg['text']   = $message;
		$this->warnings[] = $msg;
	}

	function showInstallLog() {
		global $mosConfig_live_site, $option;
?>
<script language="javascript" type="text/javascript">
function submitbutton(pressbutton) {
	var form = document.adminForm;
	if (pressbutton == 'cancel') {
		submitform( pressbutton );
		return;
	}
	submitform( pressbutton );
}
</script>
<center>
<div id="element-box"><div class="t"><div class="t"><div class="t"></div></div></div><div class="m">

<table width="95%" border="0" cellpadding="0" cellspacing="0">
<tr valign="top" align="left">
	<td width="50px"></td>
	<td>
		<span class="componentname">Proofreader <?php echo $this->releaseVersion; ?></span> <span class="componentdate">[<?php echo $this->releaseDate; ?>]</span><br />
		<span class="copyright">&copy; 2007 era (<a href="http://www.joomlatune.ru" target="_blank">JoomlaTune.ru</a>). All rights reserved!<br /></span>
	</td>
</tr>
<tr valign="top" align="left">
        <td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<?php
		if (count($this->messages)) {
?>

<tr valign="top" align="left">
        <td>&nbsp;</td>
	<td>
		<span class="installheader"><?php echo _PROOFREADER_INSTALL_LOG; ?></span>
	</td>
</tr>
<tr valign="top" align="left">
        <td>&nbsp;</td>
	<td>
		<ul style="padding: 0 0 0 20px; marign:0;">
<?php
			foreach($this->messages as $message) {
				$status_class = $message['status'] ? 'ok' : 'err';
				$status_text  = $message['status'] ? _PROOFREADER_INSTALL_OK : _PROOFREADER_INSTALL_ERROR;
?>
			<li><?php echo $message['text']; ?>: <span class="status<?php echo $status_class; ?>"><?php echo $status_text; ?></span></li>
<?php
			}
?>
			<li><span class="statusok"><b><?php echo _PROOFREADER_INSTALL_INSTALLED; ?></b></span></li>
		</ul>
	</td>
</tr>
<?php
        	}
		if (count($this->warnings)) {
?>
<tr valign="top" align="left">
        <td>&nbsp;</td>
	<td><span class="installheader"><?php echo _PROOFREADER_INSTALL_WARNINGS; ?></span></td>
</tr>
<tr valign="top" align="left">
        <td>&nbsp;</td>
	<td>
		<ul style="padding: 0 0 0 20px; marign:0;">
<?php
			foreach($this->warnings as $warning) {
?>
		<li style="padding: 0 0 5px; 0"><?php echo $warning['text']; ?></li>
<?php
			}
?>
		</ul>
	</td>
</tr>
<?php
        	}
?>
<tr valign="top" align="right">
        <td></td>
	<td align="center" style="text-align: right;">
		<div class="button-left">
			<div class="next">
				<a href="<?php echo $mosConfig_live_site; ?>/administrator/index2.php?option=com_proofreader&task=config"><?php echo _PROOFREADER_INSTALL_NEXT; ?></a>
			</div>
		</div>
	</td>
</tr>
</table>


</div><div class="b"><div class="b"><div class="b"></div></div></div></div>
</center>
<form action="index2.php" method="post" name="adminForm">
<input type="hidden" name="option" value="com_proofreader" />
<input type="hidden" name="task" value="config" />
<table width="100%" border="0" cellpadding="4" cellspacing="2" class="adminform">
</table>
</form>

<?php
	}
}







function com_install() {
	global $database, $mosConfig_absolute_path;

	$installer = new ProofreaderInstallerHTML();
//	$installer->setPermissions();

	$_MAMBOTS_SRC_PATH = $mosConfig_absolute_path.'/administrator/components/com_proofreader/mambots/system';
	$_MAMBOTS_DST_PATH = $mosConfig_absolute_path . '/mambots/system';

	@chmod( $_MAMBOTS_DST_PATH. '/', 0777);

	// install mambot com_content
	if (is_file( $_MAMBOTS_DST_PATH . '/proofreader.systembot.php' ) ) {
		// remove old files
		$database->setQuery( "DELETE FROM `#__mambots` WHERE `element` = 'proofreader.systembot';");
		@$database->query();
		@unlink( $_MAMBOTS_DST_PATH . '/proofreader.systembot.php' );
		@unlink( $_MAMBOTS_DST_PATH . '/proofreader.systembot.xml' );
	}

	@chmod( $_MAMBOTS_DST_PATH, 0777);
	$res1 = $res2 = $res3 = false;
	$res1 = @rename( $_MAMBOTS_SRC_PATH. "/proofreader.systembot.php", $_MAMBOTS_DST_PATH . "/proofreader.systembot.php");
	$res2 = @rename( $_MAMBOTS_SRC_PATH. "/proofreader.systembot.tmp", $_MAMBOTS_DST_PATH . "/proofreader.systembot.xml");
	$database->setQuery( "INSERT INTO `#__mambots` (`name`, `element`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`) VALUES ('Proofreader systembot', 'proofreader.systembot', 'system', 0, 0, 1, 0, 0, 0, '0000-00-00 00:00:00', '' );");
	$res3 = @$database->query();
	$result = $res1&&$res2&&$res3;
	$installer->addMessage( _PROOFREADER_INSTALL_INSTALL_SYSTEMBOT, $result);
	if ( !$res1 || !$res2) {
		$installer->addWarning( _PROOFREADER_INSTALL_INSTALL_SYSTEMBOT_WARNING);
	}

	if ((file_exists($mosConfig_absolute_path.'/administrator/components/com_proofreader/joomfish/contentelements/proofreader.tmp')) and
	    (file_exists($mosConfig_absolute_path.'/administrator/components/com_joomfish/contentelements'))) {
		if (file_exists( $mosConfig_absolute_path.'/administrator/components/com_joomfish/contentelements/proofreader.xml' ) ) {
			@unlink( $mosConfig_absolute_path.'/administrator/components/com_joomfish/contentelements/proofreader.xml' );
		}

		$res1 = false;
		$res1 = @rename( $mosConfig_absolute_path. '/administrator/components/com_proofreader/joomfish/contentelements/proofreader.tmp', $mosConfig_absolute_path.'/administrator/components/com_joomfish/contentelements/proofreader.xml');
		$installer->addMessage( _PROOFREADER_INSTALL_INSTALL_JOOMFISH, $res1);
		if ( !$res1) {
			$installer->addWarning( _PROOFREADER_INSTALL_INSTALL_JOOMFISH_WARNING);
		}
	}

	$installer->showInstallLog();




/*
  ?>
  <center>
  <table width="100%" border="0">
    <tr>
      <td></td>
      <td>
		<?php echo _PROOFREADER_INSTALL_TITLE; ?>
      </td>
    </tr>
    <tr>
      <td background="E0E0E0" style="border:1px solid #999;" colspan="2">
        <font color="green"><b><?php echo _PROOFREADER_INSTALL_COMPLETE; ?></b></font></code>
      </td>
    </tr>
  </table>
  </center>
  <?php
*/
}


?>